	list	p=16f877

;	ib1a.asm ICEBREAKER test program 1
;
;VERY simple led flashing program to test MAGENTA's ICEBREAKER 
;system.
;
;--------------------------------------------------------------------------;
;ICEbreaker is a Magenta Electronics Ltd. Product
;Designed by Mark Stuart.
;Copyright of Circuit, Layout, Software, and Hardware
;belongs to Magenta. 
;
;Special introductory price: Full kit 34.99 including UK VAT.
;(Special price includes serial lead and mains power unit
;for limited period only)
;
;UK Delivery is 3.00
;Overseas please enquire. 
;
;Magenta Electronics Ltd.
;135 Hunter Street
;Burton on Trent
;Staffs
;DE14 2ST
;UK
;
;Tel: 44 1283 565435
;Fax: 44 1283 546932 
;
;http://www.magenta2000.co.uk
;
;e-mail sales@magenta2000.co.uk
;
;	
;Icebreaker was published in EPE magazine March 2000
;http://www.epemag.wimborne.co.uk
;
;--------------------------------------------------------------------------;
;
;	#include p16f877.inc
;
;******* note that the 'include' file is contained
;on Microchip's MPLAB software. It is not necessary for simple projects 
;like this because only a few register files are used and can be listed
;individually as shown in the next section. If the include file is to be
;used, then 'enable' the command by removing the ';' from the first column
;and disable the following 'Register Definitions' section by adding ';' at
;the start of each line.
;
;
;
;       Register Definitions
;
;==========================================================================;

W                            EQU     H'0000'
F                            EQU     H'0001'

;----- Register Files------------------------------------------------------;

PCL                          EQU     H'0002'
STATUS                       EQU     H'0003'
FSR                          EQU     H'0004'
PORTA                        EQU     H'0005'
PORTB                        EQU     H'0006'
PORTC                        EQU     H'0007'
PORTD                        EQU     H'0008'
PORTE                        EQU     H'0009'


OPTION_REG                   EQU     H'0081'
TRISA                        EQU     H'0085'
TRISB                        EQU     H'0086'
TRISC                        EQU     H'0087'
TRISD                        EQU     H'0088'
TRISE                        EQU     H'0089'
PIE1                         EQU     H'008C'
PIE2                         EQU     H'008D'
ADCON1                       EQU     H'009F'

;----- STATUS Bits --------------------------------------------------------;

IRP                          EQU     H'0007'
RP1                          EQU     H'0006'
RP0                          EQU     H'0005'
NOT_TO                       EQU     H'0004'
NOT_PD                       EQU     H'0003'
Z                            EQU     H'0002'
DC                           EQU     H'0001'
C                            EQU     H'0000'
;
;==========================================================================;
;
; End of Register Definitions
;
;
;
	CLRF	0xA	; PCLATH
	GOTO	Initialise

	org	0004
	RETFIE	

i	equ	0x20
j	equ	0x21
k	equ	0x22
Name	equ	0x23

Initialise
	bsf	STATUS,RP0	;  Bank1 ------------------------------------------;
	clrf	OPTION_REG
	movlw	7		;
	movwf	ADCON1		;  Write 7 to set PORTA to digital I/O
	clrf	PIE1		;  Disable interrupts
	clrf	PIE2
	clrf	TRISA		;  Set ports to output by writig 0 to tris registers															
	clrf	TRISB
	clrf	TRISC
	clrf	TRISD
	clrf	TRISE
	bcf	STATUS,RP0	;  Bank0 ------------------------------------------;

Loop	movlw	0xFF
	movwf	PORTA

Loop1	movlw	0xFF
	movwf	j

Loop2	movlw	0x10
 	movwf	k

Loop3	movlw	0
	movwf	i

Loop4	movf	i,W
	sublw	5
	btfss	STATUS,0
	goto	Loop5
	Nop
	incf	i,F
	goto	Loop4

Loop5	decfsz	k,F
	goto	Loop3
	decfsz	j,F
	goto	Loop2
	decfsz	PORTA,F
	goto	Loop1
	goto	Loop
	

	END

